#include "version6.h"
#include <stdio.h>
#include <time.h>
#include <string.h>
/* Based upon Ada code */
main()
{
   #define No_Calls 10000000
   #define First_Few 10
   Generator Gen6;
   Generator Gen6a;
   Generator Temp;
   long int Count_Half;
   int i;
   long int li;
   double Rand_Value;
   char Image_Chars[Image_Width];
   char Image_Chars2[Image_Width];
   clock_t Start;
   double Interval;
   
   printf("Gen6\n");
   Reset2(&Gen6, 12345L);
   Image(&Gen6, Image_Chars);
   Value(Image_Chars, &Temp);
   if (Gen6.ix != Temp.ix || Gen6.iy != Temp.iy || Gen6.iz != Temp.iz || Gen6.it != Temp.it)
      printf("Image failure for Gen6\n");
   for (i = 0; i < First_Few; i++ ) 
     {
       Rand_Value = Random(&Gen6);
       Image(&Gen6, Image_Chars);
       printf("%.14f", Rand_Value);
       printf("%s\n", Image_Chars);
     }
   printf("Print Reset for small integers\n");
   for (li = 1; li <= First_Few; li++ ) 
     {
	 Reset2(&Gen6, li);
         Rand_Value = Random(&Gen6);
         Image(&Gen6, Image_Chars);
         printf("%.14f", Rand_Value);
         printf("%s\n", Image_Chars);
     }
   printf("Print 2 values from new start\n");
   strcpy(Image_Chars, "  1    1    1    1  ");
   Value(Image_Chars, &Gen6);   
   Rand_Value = Random(&Gen6);
   Image(&Gen6, Image_Chars);
   printf("%.14f", Rand_Value);
   printf("%s\n", Image_Chars);
   Rand_Value = Random(&Gen6);
   Image(&Gen6, Image_Chars);
   printf("%.14f", Rand_Value);
   printf("%s\n", Image_Chars);
   printf("Print values from new generator\n");
   strcpy(Image_Chars, "  1    1    1    1  ");
   Value(Image_Chars, &Gen6);   
   for (li = 0; li < First_Few; li++ ) 
     {
	 Next_Sequence(&Gen6, &Gen6a);
         Rand_Value = Random(&Gen6a);
         Image(&Gen6a, Image_Chars);
         printf("%.14f", Rand_Value);
         printf("%s\n", Image_Chars);
         Rand_Value = Random(&Gen6);
         Image(&Gen6a, Image_Chars2);
	 Next_Sequence(&Gen6, &Temp);
         Image(&Temp, Image_Chars);
	 if (strcmp(Image_Chars, Image_Chars2) != 0)
	    {
	    printf("Row and column sequences not commutative\n");
	    printf("%s\n", Image_Chars);
            }
	 Gen6.ix = Gen6a.ix;
	 Gen6.iy = Gen6a.iy;
	 Gen6.iz = Gen6a.iz;	 
	 Gen6.it = Gen6a.it;	 
     }
   Count_Half = 0;
   Start = clock();
   for (li = 0; li < No_Calls; li++ ) 
     {
       Rand_Value = Random(&Gen6);
       if (Rand_Value < 0.5)
          Count_Half += 1;
     }
   Interval = difftime(clock(), Start);
   printf("Number less than half: %ld", Count_Half);
   printf(" from  %ld\n", (long int) No_Calls);
   printf("Speed of Generator, Version 6\n");
   printf("Number of calls per second %ld\n", (long int) (No_Calls*CLOCKS_PER_SEC/Interval));
}

