package Version5 is

 type Generator is private;
 subtype Uniformly_Distributed is Long_Float range 0.0 .. 1.0;

 procedure Random (Gen: in out Generator; Value: out Uniformly_Distributed);

 procedure Reset (Gen       : out Generator;
                  Initiator : in Positive);

 procedure Reset(Gen       : out Generator);


 Image_Width : constant := 44;
 subtype String_State is String(1..Image_Width);

 function Image (Gen   : in Generator) return String_State;

 function Value (Coded_State: String_State) return Generator;

 function Next_Sequence(Gen   : in Generator) return Generator;

private
  type Generator is record
                    ix, iy, iz, iu: Long_Long_Integer := 1;
                    end record;

end Version5;


