#include "unif01.h"
#include "bbattery.h"
 

int main (void) 
{ 
   unif01_Gen *gen1, *gen2, *gen3, *gen4;
   
   gen1 = ulcg_CreateLCG (30269,171, 0, 26656);
   gen2 = ulcg_CreateLCG (30307,172, 0, 2092); 
   gen3 = ulcg_CreateLCG (30323,170, 0, 3794);
   gen4 = unif01_CreateCombAdd3 (gen1, gen2, gen3, "Wichmann-Hill");
 
   bbattery_SmallCrush (gen4);
   
   unif01_DeleteExternGen01 (gen1);
   unif01_DeleteExternGen01 (gen2);
   unif01_DeleteExternGen01 (gen3);
   unif01_DeleteExternGen01 (gen4);

   return 0; 

}



